//<?php

abstract class easypopup_hook_showPopup extends _HOOK_CLASS_
{
	public function finish()
	{
		try
		{
			if ( \IPS\Settings::i()->espp_on == 1 && \IPS\Dispatcher::i()->controllerLocation == 'front' && ! \IPS\Request::i()->isAjax() )
			{
				foreach( \IPS\easypopup\Popup::roots() as $popup )
				{
					if ( $popup->canSeePopup() && $popup->open == 1 )
					{
						if ($popup->content_type == 'html' )
						{
							$content = \IPS\Settings::i()->espp_useEditor != 1 ? $this->displayContent( $popup->content ) : $popup->content;
						}
						else
						{
							$img = \IPS\File::get( 'easypopup_Image', $popup->image )->url;
							if ( $popup->img_linkto )
							{
								if ( $popup->link_newtab == 1 )
								{
									$onclick = "onclick=\"window.open('{$popup->img_linkto}','_blank');\"";
								}
								else
								{
									$onclick = "onclick=\"window.location='{$popup->img_linkto}';\"";
								}
								$content = "<a href='#' class='bClose' {$onclick}><img src='{$img}' class='popupimg'></a>";
							}
							else $content = "<img src='{$img}' class='popupimg'>";
						}
						
						$content = $this->htmlSafe( $content );
						
						\IPS\Output::i()->endBodyCode .= \IPS\Theme::i()->getTemplate( 'embed', 'easypopup', 'front' )->showPopup( $popup, $content );
					}
				}
			}
			
			parent::finish();
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
	protected function displayContent( $content )
	{
		try
		{
			ob_start();
			eval( "?>" . $content . "<?php " );
			$content = ob_get_contents();
			ob_end_clean();
				
			# Advertisement code
			preg_match_all( '/{advertisement=[\'"](.+?)[\'"]}/', $content, $match );
	
			for ( $i = 0 ; $i < count( $match[0] ) ; $i++ )
			{
				$content = str_replace( $match[0][$i], (string) \IPS\core\Advertisement::loadByLocation( $match[1][$i] ), $content);	
			}
	
			# Output
			return $content;
			}
			catch ( \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
	}	
	
	protected function htmlSafe( $content )
	{
		try
		{
			$content = str_replace("fileStore.core_Emoticons", "", $content);
			$content = str_replace("fileStore.core_Attachment", "", $content);		
			$content = str_replace("<>", "", $content);			
			$content = str_replace("%3C%3E", "", $content);
			$content = str_replace( '<___base_url___>', rtrim( \IPS\Settings::i()->base_url, '/' ), $content );
					
			preg_match_all( '~<img[^>]*(?<!_mce_)src\s?=\s?([\'"])((?:(?!\1).)*)[^>]*>~i', $content, $match );
			for ( $e = 0 ; $e < count($match[0]) ; $e++ )
			{
				if (mb_strpos($match[0][$e], 'data-fileid') !== false)
				{
					$url = (string) \IPS\File::get( 'core_Attachment', $match[2][$e] )->url;
					$content = str_replace($match[0][$e], "<img src='" . $url . "'>", $content);
					
				}	
				if (mb_strpos($match[0][$e], 'data-emoticon') !== false)
				{
					$url = (string) \IPS\File::get( 'core_Emoticons', $match[2][$e] )->url;
					$content = str_replace($match[0][$e], "<img src='" . $url . "'>", $content);
				}			
			}
	
			$content = htmlentities($content);
			$content = trim( preg_replace( '/\s+/', ' ', $content) );
			return $content;
		}
		catch ( \RuntimeException $e )
		{
			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return call_user_func_array( 'parent::' . __FUNCTION__, func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
	
}